Description

Hi,

| specialised the WltemDelegate class and | saw that the editor widget is never destructed. The default implementation of
doCloseEditor is:

void WItemDelegate::doCloseEditor (WWidget *editor, bool save) const
{

closeEditor () .emit (editor, save);
When the editor has to be destructed? | suppose after emitting the closeEditor signal, i.e., :
void WItemDelegate::doCloseEditor (WWidget *editor, bool save) const
{

closeEditor () .emit (editor, save);

delete editor;

Best regards,

Stoycho

History

#1 - 02/19/2015 10:39 PM - Koen Deforche
- Status changed from New to Rejected

- Assignee set to Koen Deforche

Hey,

The 'editor' widget is in fact simply the widget rendered by the item delegate for a particular cell: it's treated in the same way as a normal view widget,
and thus the tableview or treeview will delete it.

Regards,

koen

#2 - 02/20/2015 09:22 AM - Ctonuo CrechaHoB Stoycho Stefanov

Hey Koen,

let us consider the following scenario, where you're editing the same cell for example 10 times consecutively. Than you have created 10 editor
widgets for the same cell, because every time you're editing createEditor is called and a new editor widget is instantiated. | think it's wrong to create
every time a new editor when editing, not reuse it and destroy them with the parent view widget. With other words, after doCloseEditor is called the
editor widget still exists despite it's never accessed again and still be there until the view widget is destructed. | thing it's much better to delete the
editor before exiting doCloseEditor, OR reuse it and create it only once by the first call of createEditor.

Regards,

Stoycho

#3 - 02/20/2015 11:06 AM - Koen Deforche
- Status changed from Rejected to Feedback
In the scenario you describe, each time you code the editor it will be destroyed because the editor is later replaced by a view. So in no situation will
there exist more than one widget for a particular cell at the same time. The fact that we do not reuse a previous editor has to do with flexibility, as that
would impose that a single cell should always have the same editor widget.

#4 - 02/20/2015 11:25 AM - Ctonuo CredpaHoB Stoycho Stefanov

Ok, perhaps | have a bug in my delegate specialisation. But If | do not delete the editor explicitly in doCloseEditor, editor widgets are never destroyed,
neither by replacing with a view nor by the tree view destructor. I'll let you know whether | can reproduce it in a test case application. Unfortunately, |
do not have currently time for this.

Regards,

Stoycho

#5 - 03/02/2015 04:14 PM - Koen Deforche

Yes, | would be interested in such a test case as we cannot reproduce this with the standard item delegate or a custom one (like ComboBoxDelegate)

#6 - 03/24/2015 05:41 PM - Ctronyo CrechaHoB Stoycho Stefanov

- File Main.cpp added

Hey,

| got it. Here is the test case for wt-git revision 1084.

The editor widget is destroyed when editing within column 0, bit not within column 1, of a tree view.
regards,

Stoycho

#7 - 03/24/2015 08:03 PM - Koen Deforche

- Status changed from Feedback to InProgress

- Assignee changed from Koen Deforche to Benoit Daccache

- Target version set to 3.3.4

#8 - 03/25/2015 04:37 PM - Benoit Daccache

- Status changed from InProgress to Resolved

#9 - 03/26/2015 09:39 PM - Koen Deforche

- Status changed from Resolved to Closed

Files

Main.cpp 3.27 KB 03/24/2015 Croiiyo Credparos Stoycho Stefanov
